﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTabControl;
using Infragistics.Win.UltraWinTabs;

namespace UltraTabControlCreationFilterAddButton
{
    public partial class Form1 : Form
    {
        public  static int TabCount;

        public Form1()
        {
            InitializeComponent();

            int Width = ultraTabControl1.TabSize.Width * ultraTabControl1.Tabs.VisibleTabsCount + 5;
            ultraTabControl1.CreationFilter = new CreatingTextUIElement(Width);
        }

        private void ultraTabControl1_Click(object sender, EventArgs e)
        {
            if (ultraTabControl1.UIElement.ElementWithMouseCapture == null) return;
            if (ultraTabControl1.UIElement.ElementWithMouseCapture.GetType() == typeof(ButtonUIElement))
            {
                UltraTab tab =  ultraTabControl1.Tabs.Add((ultraTabControl1.Tabs.Count +1).ToString(), "tab" + (ultraTabControl1.Tabs.Count +1).ToString());
                tab.FixedWidth = 80;
                int Width = ultraTabControl1.TabSize.Width * ultraTabControl1.Tabs.VisibleTabsCount + 5;
                ultraTabControl1.CreationFilter = new CreatingTextUIElement(Width);
            }
        }

        private void ultraTabControl1_TabClosed(object sender, TabClosedEventArgs e)
        {
            int Width = ultraTabControl1.TabSize.Width * ultraTabControl1.Tabs.VisibleTabsCount + 5;
            ultraTabControl1.CreationFilter = new CreatingTextUIElement(Width);
        }
    }

    public class CreatingTextUIElement : IUIElementCreationFilter
    {
        private int width;

        public CreatingTextUIElement(int Width)
        {
            this.width = Width;
        }
        public void AfterCreateChildElements(UIElement parent)
        {
            TabHeaderAreaUIElement El = parent as TabHeaderAreaUIElement;
            if (El != null)
            {
                ButtonUIElement newBB = new ButtonUIElement(El);
                newBB.Text = "+";
                //newBB.TextHAlign = HAlign.Left;
                newBB.Rect = new Rectangle(El.Rect.X + width, El.Rect.Y + 1, 18, 20);
                El.ChildElements.Add(newBB);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
